; reassembly of "MOC1K.hex"
; created by ReAVR V3.2.0
; at 2008/11/20 - 19:05:06
; for Atmel AVR assembler
;---------------------------------------
; AVR_TYPE=MEGA8
.DEVICE ATmega8  
; FLASH_SIZE=8KB
; SRAM_START=0x60
.include <m8def.inc>
;---------------------------------------
	.cseg
	.org	0x0000
;---------------------------------------
; byte constants:
;
.equ	k00	= 0x00	;
.equ	k01	= 0x01	;
.equ	k02	= 0x02	;
.equ	k03	= 0x03	;
.equ	k04	= 0x04	;
.equ	k05	= 0x05	;
.equ	k06	= 0x06	;
.equ	k07	= 0x07	;
.equ	k08	= 0x08	;
.equ	k09	= 0x09	;
.equ	k0A	= 0x0A	;
.equ	k0B	= 0x0B	;
.equ	k0C	= 0x0C	;
.equ	k0D	= 0x0D	;
.equ	k0E	= 0x0E	;
.equ	k0F	= 0x0F	;
.equ	k14	= 0x14	;
.equ	k18	= 0x18	;
.equ	k2A	= 0x2A	; '*'
.equ	k48	= 0x48	; 'H'
.equ	k55	= 0x55	; 'U'
.equ	k59	= 0x59	; 'Y'
.equ	k60	= 0x60	; '`'
.equ	k65	= 0x65	; 'e'
.equ	k66	= 0x66	; 'f'
.equ	k67	= 0x67	; 'g'
.equ	k68	= 0x68	; 'h'
.equ	k69	= 0x69	; 'i'
.equ	k80	= 0x80	;
.equ	k98	= 0x98	;
.equ	kC0	= 0xC0	; ''
.equ	kDB	= 0xDB	; ''
.equ	kE0	= 0xE0	; ''
.equ	kE2	= 0xE2	; ''
.equ	kE6	= 0xE6	; ''
.equ	kFF	= 0xFF	; ''
;
; io register addresses:
;
;.equ	ADCL	= 0x04
;.equ	ADCH	= 0x05
;.equ	ADCSRA	= 0x06
;.equ	ADMUX	= 0x07
;.equ	UBRRH	= 0x40
;.equ	UBRRL	= 0x09
;.equ	UCSRB	= 0x0A
;.equ	UCSRA	= 0x0B
;.equ	UDR		= 0x0C
;.equ	TCNT0	= 0x32
;.equ	TCCR0	= 0x33
;.equ	TIMSK	= 0x39
.equ	SP		= 0x3D
;.equ	EEARL	= 0x3E
;.equ	SREG	= 0x3F
;
; bit numbers:
;
.equ	b0	= 0x00
.equ	b1	= 0x01
.equ	b2	= 0x02
.equ	b3	= 0x03
.equ	b4	= 0x04
.equ	b5	= 0x05
.equ	b6	= 0x06
.equ	b7	= 0x07
;---------------------------------------
;
L0000:
	rjmp	_reset	; L0022
;	-----------	jump on last line
	.dw	0xFFFF	; pc=0x0001(0x0002)
	.dw	0xFFFF	; pc=0x0002(0x0004)
	.dw	0xFFFF	; pc=0x0003(0x0006)
	.dw	0xFFFF	; pc=0x0004(0x0008)
	.dw	0xFFFF	; pc=0x0005(0x000A)
	.dw	0xFFFF	; pc=0x0006(0x000C)
	.dw	0xFFFF	; pc=0x0007(0x000E)
	.dw	0xFFFF	; pc=0x0008(0x0010)
	rjmp	L0016
;	-----------	jump on last line
	.dw	0xFFFF	; pc=0x000A(0x0014)
	rjmp	L000C
;	-----------	jump on last line
L000C:
	in	r0,SREG
	mov	r1,r16
	in	r16,UDR
	ldi	r16,k2A
	push	r16
	ldi	r16,k00
	push	r16
	mov	r16,r1
	out	SREG,r0
	reti
;----------------------*
; pc=0x16(0x2C)
;
L0016:
	in	r0,SREG
	mov	r1,r16
	dec	r25
	 breq	L001B
;	-----		branch on last line
	reti
;----------------------*
; pc=0x1B(0x36)
;
L001B:
	ldi	r16,k2A
	push	r16
	ldi	r16,k00
	push	r16
	mov	r16,r1
	out	SREG,r0
	reti
;----------------------*
; pc=0x22(0x44)
;
_reset:
; L0022:
;;	ldi	r16,6			;;
;;	out	UCSRC,r16		;;my

;;	ldi	r16,0
;;	out UBRRH,r16
	ldi	r16,1		;;my for 20MHz was 1 for 3.38MHz
	out	UBRRL,r16
	ldi	r16,k18
	out	UCSRB,r16
	ldi	r16,kC0



	out	ADMUX,r16
	ldi	r16,kE0
	out	ADCSRA,r16
L002A:
	ldi	r16,k04
	out	EEARL,r16
	ldi	r16,k59
	out	SP,r16
	cli
	ldi	r16,k18
	out	UCSRB,r16
	ldi	r16,kDB
	out	TCNT0,r16
	ldi	r25,k14
	ldi	r16,k01
	out	TIMSK,r16
	ldi	r16,k05
	out	TCCR0,r16
	sei
L0039:
;	--------- this is skippy
;;	 sbis	UCSRA,b7
;;	 rjmp	L0039
;	--------- last may be skipped
; pc=0x3B(0x76)
;
	in	r18,UDR
L003C:
;	--------- this is skippy
;;	 sbis	UCSRA,b7
;;	 rjmp	L003C
;	--------- last may be skipped
; pc=0x3E(0x7C)
;
	in	r19,UDR
L003F:
;	--------- this is skippy
;;	 sbis	UCSRA,b7
;;	 rjmp	L003F
;	--------- last may be skipped
; pc=0x41(0x82)
;
	in	r20,UDR
L0042:
;	--------- this is skippy
;;	 sbis	UCSRA,b7
;;	 rjmp	L0042
;	--------- last may be skipped
; pc=0x44(0x88)
;
	in	r21,UDR
L0045:
;	--------- this is skippy
;;	 sbis	UCSRA,b7
;;	 rjmp	L0045
;	--------- last may be skipped
; pc=0x47(0x8E)
;
	in	r22,UDR
	cli
	ldi	r16,k98
	out	UCSRB,r16



	ldi	r16,k00
	out	TIMSK,r16
	ldi	r16,k00
	out	TCCR0,r16
	ldi	r16,k00
	add	r16,r18
	add	r16,r19
	add	r16,r20
	add	r16,r21
	cp	r16,r22
	 brne	L002A
;	-----		branch on last line
	mov	r16,r18
	andi	r16,k01
	cpi	r16,k01
	 brne	L0062
;	-----		branch on last line
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
L0062:
;;	cpi	r19,k55
;;	 brne	L0069
;	-----		branch on last line
loop:					;my
	ldi	r16,k55
	out	UDR,r16
L0066:
;	--------- this is skippy
	 sbis	UCSRA,b6
	 rjmp	L0066
;	--------- last may be skipped
; pc=0x68(0xD0)
;
	rjmp	loop		;my
	rjmp	L002A
	
;	-----------	jump on last line
L0069:
	cpi	r19,k00
	 brne	L006E
;	-----		branch on last line
	 rcall	L009D
	 rcall	L0338
	rjmp	L002A
;	-----------	jump on last line
L006E:
	cpi	r19,k01
	 brne	L0073
;	-----		branch on last line
	 rcall	L010A
	 rcall	L0338
	rjmp	L002A
;	-----------	jump on last line
L0073:
	cpi	r19,k02
	 brne	L0078
;	-----		branch on last line
	 rcall	L010A
	 rcall	L0338
	rjmp	L002A
;	-----------	jump on last line
L0078:
	cpi	r19,k03
	 brne	L007D
;	-----		branch on last line
	 rcall	L010A
	 rcall	L0338
	rjmp	L002A
;	-----------	jump on last line
L007D:
	cpi	r19,k04
	 brne	L0082
;	-----		branch on last line
	 rcall	L010A
	 rcall	L0338
	rjmp	L002A
;	-----------	jump on last line
L0082:
	cpi	r19,k05
	 brne	L0087
;	-----		branch on last line
	 rcall	L010A
	 rcall	L0338
	rjmp	L002A
;	-----------	jump on last line
L0087:
	cpi	r19,k65
	 brne	L008B
;	-----		branch on last line
	 rcall	L0282
	rjmp	L002A
;	-----------	jump on last line
L008B:
	cpi	r19,k66
	 brne	L008F
;	-----		branch on last line
	 rcall	L0282
	rjmp	L002A
;	-----------	jump on last line
L008F:
	cpi	r19,k67
	 brne	L0093
;	-----		branch on last line
	 rcall	L0282
	rjmp	L002A
;	-----------	jump on last line
L0093:
	cpi	r19,k68
	 brne	L0097
;	-----		branch on last line
	 rcall	L0282
	rjmp	L002A
;	-----------	jump on last line
L0097:
	cpi	r19,k69
	 brne	L009B
;	-----		branch on last line
	 rcall	L0282
	rjmp	L002A
;	-----------	jump on last line
L009B:
	 rcall	L01AF
	rjmp	L002A
;	-----------	jump on last line
L009D:
	ldi	r16,k98
	out	UCSRB,r16
	sei
	mov	r16,r18
	rol	r16
	rol	r16
	 brcc	L00D8
;	-----		branch on last line
	rol	r16
	 brcc	L00BF
;	-----		branch on last line
L00A6:
	ldi	r22,kC0
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	clc
	sbc	r16,r23
	sbc	r17,r24
	 brcc	L00A6
;	-----		branch on last line
L00B2:
	ldi	r22,kC0
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	clc
	sbc	r23,r16
	sbc	r24,r17
	 brcc	L00B2
;	-----		branch on last line
	rjmp	L00D8
;	-----------	jump on last line
L00BF:
	ldi	r22,kC0
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	clc
	sbc	r23,r16
	sbc	r24,r17
	 brcc	L00BF
;	-----		branch on last line
L00CB:
	ldi	r22,kC0
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	clc
	sbc	r16,r23
	sbc	r17,r24
	 brcc	L00CB
;	-----		branch on last line
	rjmp	L00D8
;	-----------	jump on last line
L00D8:
	ldi	r27,k00
	ldi	r26,k60
L00DA:
	ldi	r16,kC0
	out	ADCSRA,r16
	in	r16,ADCL
	st	X+,r16
	in	r16,ADCH
	st	X+,r16
	ldi	r16,kE0
	out	ADCSRA,r16
	nop
	cpi	r26,k60
	 brne	L00DA
;	-----		branch on last line
	nop
L00E6:
	ldi	r16,kC0
	out	ADCSRA,r16
	in	r16,ADCL
	st	X+,r16
	in	r16,ADCH
	st	X+,r16
	ldi	r16,kE0
	out	ADCSRA,r16
	nop
	cpi	r26,k60
	 brne	L00E6
;	-----		branch on last line
	nop
L00F2:
	ldi	r16,kC0
	out	ADCSRA,r16
	in	r16,ADCL
	st	X+,r16
	in	r16,ADCH
	st	X+,r16
	ldi	r16,kE0
	out	ADCSRA,r16
	nop
	cpi	r26,k60
	 brne	L00F2
;	-----		branch on last line
	nop
L00FE:
	ldi	r16,kC0
	out	ADCSRA,r16
	in	r16,ADCL
	st	X+,r16
	in	r16,ADCH
	st	X+,r16
	ldi	r16,kE0
	out	ADCSRA,r16
	nop
	cpi	r26,k48
	 brne	L00FE
;	-----		branch on last line
	ret
;----------------------*
; pc=0x10A(0x214)
;
L010A:
	ldi	r16,kE2
	out	ADCSRA,r16
	 rcall	L02F6
	ldi	r16,k98
	out	UCSRB,r16
	sei
	mov	r16,r18
	rol	r16
	rol	r16
	 brcc	L014C
;	-----		branch on last line
	rol	r16
	 brcc	L0131
;	-----		branch on last line
L0116:
	ldi	r22,k80
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	 rcall	L017E
	clc
	sbc	r16,r23
	sbc	r17,r24
	 brcc	L0116
;	-----		branch on last line
L0123:
	ldi	r22,k80
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	 rcall	L017E
	clc
	sbc	r23,r16
	sbc	r24,r17
	 brcc	L0123
;	-----		branch on last line
	rjmp	L014C
;	-----------	jump on last line
L0131:
	ldi	r22,k80
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	 rcall	L017E
	clc
	sbc	r23,r16
	sbc	r24,r17
	 brcc	L0131
;	-----		branch on last line
L013E:
	ldi	r22,k80
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	 rcall	L017E
	clc
	sbc	r16,r23
	sbc	r17,r24
	 brcc	L013E
;	-----		branch on last line
	rjmp	L014C
;	-----------	jump on last line
L014C:
	ldi	r27,k00
	ldi	r26,k60
L014E:
	ldi	r16,k80
	out	ADCSRA,r16
	in	r16,ADCL
	st	X+,r16
	in	r16,ADCH
	st	X+,r16
	ldi	r16,kE0
	out	ADCSRA,r16
	 rcall	L017E
	cpi	r26,k60
	 brne	L014E
;	-----		branch on last line
	nop
L015A:
	ldi	r16,k80
	out	ADCSRA,r16
	in	r16,ADCL
	st	X+,r16
	in	r16,ADCH
	st	X+,r16
	ldi	r16,kE0
	out	ADCSRA,r16
	 rcall	L017E
	cpi	r26,k60
	 brne	L015A
;	-----		branch on last line
	nop
L0166:
	ldi	r16,k80
	out	ADCSRA,r16
	in	r16,ADCL
	st	X+,r16
	in	r16,ADCH
	st	X+,r16
	ldi	r16,kE0
	out	ADCSRA,r16
	 rcall	L017E
	cpi	r26,k60
	 brne	L0166
;	-----		branch on last line
	nop
L0172:
	ldi	r16,k80
	out	ADCSRA,r16
	in	r16,ADCL
	st	X+,r16
	in	r16,ADCH
	st	X+,r16
	ldi	r16,kE0
	out	ADCSRA,r16
	 rcall	L017E
	cpi	r26,k48
	 brne	L0172
;	-----		branch on last line
	ret
;----------------------*
; pc=0x17E(0x2FC)
;
L017E:
	cpi	r19,k01
	 brne	L0188
;	-----		branch on last line
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x188(0x310)
;
L0188:
	cpi	r19,k02
	 brne	L0196
;	-----		branch on last line
	 rcall	L02E0
	 rcall	L02DC
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x196(0x32C)
;
L0196:
	cpi	r19,k03
	 brne	L019C
;	-----		branch on last line
	 rcall	L02E6
	 rcall	L02DC
	 rcall	L02DC
	ret
;----------------------*
; pc=0x19C(0x338)
;
L019C:
	cpi	r19,k04
	 brne	L01A5
;	-----		branch on last line
	 rcall	L02E6
	 rcall	L02E6
	 rcall	L02E0
	 rcall	L02E0
	nop
	nop
	ret
;----------------------*
; pc=0x1A5(0x34A)
;
L01A5:
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E6
	nop
	nop
	nop
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x1AF(0x35E)
;
L01AF:
	ldi	r16,kE6
	out	ADCSRA,r16
	 rcall	L02F6
	ldi	r16,k98
	out	UCSRB,r16
	sei
	mov	r16,r18
	rol	r16
	rol	r16
	 brcc	L01F5
;	-----		branch on last line
	rol	r16
	 brcc	L01D8
;	-----		branch on last line
L01BB:
	ldi	r22,k80
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	 rcall	L021F
	 rcall	L021F
	clc
	sbc	r16,r23
	sbc	r17,r24
	 brcc	L01BB
;	-----		branch on last line
L01C9:
	ldi	r22,k80
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	 rcall	L021F
	 rcall	L021F
	clc
	sbc	r23,r16
	sbc	r24,r17
	 brcc	L01C9
;	-----		branch on last line
	rjmp	L01F5
;	-----------	jump on last line
L01D8:
	ldi	r22,k80
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	 rcall	L021F
	 rcall	L021F
	clc
	sbc	r23,r16
	sbc	r24,r17
	 brcc	L01D8
;	-----		branch on last line
L01E6:
	ldi	r22,k80
	out	ADCSRA,r22
	in	r16,ADCL
	in	r17,ADCH
	ldi	r22,kE0
	out	ADCSRA,r22
	mov	r23,r20
	mov	r24,r21
	 rcall	L021F
	 rcall	L021F
	clc
	sbc	r16,r23
	sbc	r17,r24
	 brcc	L01E6
;	-----		branch on last line
	rjmp	L01F5
;	-----------	jump on last line
L01F5:
	ldi	r27,k00
	ldi	r26,k60
L01F7:
	in	r16,ADCL
	in	r17,ADCH
	out	UDR,r16
	 rcall	L021F
	out	UDR,r17
	 rcall	L021F
	adiw	r26,k02
	cpi	r26,k60
	 brne	L01F7
;	-----		branch on last line
	nop
L0201:
	in	r16,ADCL
	in	r17,ADCH
	out	UDR,r16
	 rcall	L021F
	out	UDR,r17
	 rcall	L021F
	adiw	r26,k02
	cpi	r26,k60
	 brne	L0201
;	-----		branch on last line
	nop
L020B:
	in	r16,ADCL
	in	r17,ADCH
	out	UDR,r16
	 rcall	L021F
	out	UDR,r17
	 rcall	L021F
	adiw	r26,k02
	cpi	r26,k60
	 brne	L020B
;	-----		branch on last line
	nop
L0215:
	in	r16,ADCL
	in	r17,ADCH
	out	UDR,r16
	 rcall	L021F
	out	UDR,r17
	 rcall	L021F
	adiw	r26,k02
	cpi	r26,k48
	 brne	L0215
;	-----		branch on last line
	ret
;----------------------*
; pc=0x21F(0x43E)
;
L021F:
	cpi	r19,k06
	 brne	L022F
;	-----		branch on last line
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E6
	 rcall	L02DC
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x22F(0x45E)
;
L022F:
	cpi	r19,k07
	 brne	L0237
;	-----		branch on last line
	 rcall	L02F6
	 rcall	L02ED
	 rcall	L02E6
	 rcall	L02E0
	 rcall	L02E0
	ret
;----------------------*
; pc=0x237(0x46E)
;
L0237:
	cpi	r19,k08
	 brne	L023F
;	-----		branch on last line
	 rcall	L0300
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E0
	 rcall	L02E0
	ret
;----------------------*
; pc=0x23F(0x47E)
;
L023F:
	cpi	r19,k09
	 brne	L0247
;	-----		branch on last line
	 rcall	L0300
	 rcall	L0300
	 rcall	L02F6
	 rcall	L02ED
	 rcall	L02DC
	ret
;----------------------*
; pc=0x247(0x48E)
;
L0247:
	cpi	r19,k0A
	 brne	L0250
;	-----		branch on last line
	 rcall	L030C
	 rcall	L0300
	 rcall	L02F6
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E6
	ret
;----------------------*
; pc=0x250(0x4A0)
;
L0250:
	cpi	r19,k0B
	 brne	L0259
;	-----		branch on last line
	 rcall	L0319
	 rcall	L0300
	 rcall	L0300
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E6
	ret
;----------------------*
; pc=0x259(0x4B2)
;
L0259:
	cpi	r19,k0C
	 brne	L0262
;	-----		branch on last line
	 rcall	L0319
	 rcall	L0319
	 rcall	L030C
	 rcall	L0300
	 rcall	L02ED
	 rcall	L02ED
	ret
;----------------------*
; pc=0x262(0x4C4)
;
L0262:
	cpi	r19,k0D
	 brne	L026B
;	-----		branch on last line
	 rcall	L0328
	 rcall	L0319
	 rcall	L030C
	 rcall	L0300
	 rcall	L0300
	 rcall	L02F6
	ret
;----------------------*
; pc=0x26B(0x4D6)
;
L026B:
	cpi	r19,k0E
	 brne	L0276
;	-----		branch on last line
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0319
	 rcall	L0319
	 rcall	L0300
	 rcall	L0300
	 rcall	L02F6
	ret
;----------------------*
; pc=0x276(0x4EC)
;
L0276:
	cpi	r19,k0F
	 brne	L0281
;	-----		branch on last line
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0328
	 rcall	L0319
	 rcall	L0300
L0281:
	ret
;----------------------*
; pc=0x282(0x504)
;
L0282:
	ldi	r16,kE6
	out	ADCSRA,r16
	 rcall	L02F6
L0285:
	in	r16,ADCL
	in	r17,ADCH
	cpi	r20,k01
	 breq	L029D
;	-----		branch on last line
	cpi	r20,k02
	 breq	L0296
;	-----		branch on last line
	clc
	ror	r17
	ror	r16
	ror	r17
	ror	r16
	nop
	nop
	nop
	nop
	nop
	rjmp	L02A8
;	-----------	jump on last line
L0296:
	clc
	ror	r17
	ror	r16
	cpi	r17,k00
	 breq	L02A6
;	-----		branch on last line
	ldi	r16,kFF
	rjmp	L02A8
;	-----------	jump on last line
L029D:
	nop
	nop
	nop
	nop
	nop
	nop
	cpi	r17,k00
	 breq	L02A6
;	-----		branch on last line
	ldi	r16,kFF
L02A6:
	nop
	nop
L02A8:
	out	UDR,r16
	cpi	r19,k65
	 brne	L02B3
;	-----		branch on last line
	 rcall	L02F6
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E6
	 rcall	L02E6
	 rcall	L02DC
	 rcall	L02DC
	rjmp	L02D9
;	-----------	jump on last line
L02B3:
	cpi	r19,k66
	 brne	L02BB
;	-----		branch on last line
	 rcall	L0300
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E0
	 rcall	L02E0
	rjmp	L02D9
;	-----------	jump on last line
L02BB:
	cpi	r19,k67
	 brne	L02C7
;	-----		branch on last line
	 rcall	L0300
	 rcall	L0300
	 rcall	L02F6
	 rcall	L02ED
	 rcall	L02E0
	 rcall	L02DC
	nop
	nop
	nop
	rjmp	L02D9
;	-----------	jump on last line
L02C7:
	cpi	r19,k68
	 brne	L02D1
;	-----		branch on last line
	 rcall	L030C
	 rcall	L0300
	 rcall	L0300
	 rcall	L02F6
	 rcall	L02F6
	 rcall	L02ED
	 rcall	L02E6
	rjmp	L02D9
;	-----------	jump on last line
L02D1:
	 rcall	L0319
	 rcall	L0300
	 rcall	L0300
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E6
	 rcall	L02E6
	 rcall	L02E0
L02D9:
;	--------- this is skippy
	 sbis	UCSRA,b7
	 rjmp	L0285
;	--------- last may be skipped
; pc=0x2DB(0x5B6)
;
	ret
;----------------------*
; pc=0x2DC(0x5B8)
;
L02DC:
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x2E0(0x5C0)
;
L02E0:
	 rcall	L02DC
	 rcall	L02DC
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x2E6(0x5CC)
;
L02E6:
	 rcall	L02E0
	 rcall	L02E0
	 rcall	L02E0
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x2ED(0x5DA)
;
L02ED:
	 rcall	L02E6
	 rcall	L02E6
	 rcall	L02E0
	 rcall	L02E0
	 rcall	L02E0
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x2F6(0x5EC)
;
L02F6:
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E0
	 rcall	L02E0
	 rcall	L02E0
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x300(0x600)
;
L0300:
	 rcall	L02F6
	 rcall	L02F6
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E0
	 rcall	L02E0
	 rcall	L02E0
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x30C(0x618)
;
L030C:
	 rcall	L0300
	 rcall	L0300
	 rcall	L0300
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E0
	 rcall	L02E0
	 rcall	L02E0
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x319(0x632)
;
L0319:
	 rcall	L030C
	 rcall	L030C
	 rcall	L0300
	 rcall	L0300
	 rcall	L0300
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E0
	 rcall	L02E0
	 rcall	L02E0
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x328(0x650)
;
L0328:
	 rcall	L0319
	 rcall	L0319
	 rcall	L0319
	 rcall	L0300
	 rcall	L0300
	 rcall	L0300
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02ED
	 rcall	L02E0
	 rcall	L02E0
	 rcall	L02E0
	nop
	nop
	nop
	ret
;----------------------*
; pc=0x338(0x670)
;
L0338:
	ldi	r27,k00
	ldi	r26,k60
L033A:
	ld	r16,X+
	sbi	UCSRA,b6
	out	UDR,r16
L033D:
;	--------- this is skippy
	 sbis	UCSRA,b6
	 rjmp	L033D
;	--------- last may be skipped
; pc=0x33F(0x67E)
;
	cpi	r27,k04
	 breq	L0342
;	-----		branch on last line
	rjmp	L033A
;	-----------	jump on last line
L0342:
	cpi	r26,k48
	 breq	L0345
;	-----		branch on last line
	rjmp	L033A
;	-----------	jump on last line
L0345:
	ret
;----------------------*
; pc=0x346(0x68C)
;
; last flash byte address = 0x068B
; last flash word address = 0x0345
;---------------------------------------
; Code not seems to use any RAM.
;---------------------------------------
;<eof>
